/***************************************************************************
 *
 *  ZXEmuT -- ZX Spectrum Emulator with Tcl scripting
 *
 *  Copyright (C) 2012-2022 Ketmar Dark <ketmar@ketmar.no-ip.org>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, version 3 of the License ONLY.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **************************************************************************/
#include <stdint.h>

#include "diskled.h"
#include "libvideo/video.h"
#include "emuvars.h"


////////////////////////////////////////////////////////////////////////////////
static const uint8_t iconDisk[588] = {
  0x18,0x18,0x13,0x13,0x14,0x14,0x3F,0x3F,0x3F,0x13,0x13,0x3F,0x13,0x3F,0x3F,0x13,0x13,0x3F,0x13,
  0x3F,0x14,0x3F,0x3F,0x13,0x3F,0x13,0x12,0x3E,0x3E,0x3E,0x14,0x14,0x14,0x14,0x14,0x14,0x14,0x3E,
  0x14,0x14,0x3E,0x14,0x14,0x15,0x3E,0x14,0x14,0x15,0x3E,0x12,0x11,0x14,0x3F,0x3F,0x13,0x13,0x13,
  0x3F,0x3F,0x13,0x14,0x13,0x13,0x3F,0x13,0x13,0x3F,0x3F,0x3F,0x13,0x14,0x3F,0x13,0x12,0x11,0x13,
  0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x14,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x14,0x13,
  0x13,0x14,0x12,0x11,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x28,0x29,0x29,0x29,0x27,0x13,
  0x13,0x13,0x13,0x13,0x13,0x13,0x14,0x11,0x11,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x2A,0x3B,0x39,
  0x2E,0x39,0x30,0x2F,0x3B,0x3D,0x13,0x13,0x13,0x13,0x13,0x13,0x11,0x11,0x13,0x13,0x13,0x13,0x13,
  0x2A,0x39,0x3B,0x2C,0x3C,0x3D,0x3D,0x3D,0x3E,0x3C,0x3A,0x36,0x3D,0x13,0x13,0x13,0x13,0x11,0x11,
  0x13,0x13,0x13,0x13,0x3D,0x36,0x3C,0x32,0x3D,0x29,0x40,0x40,0x40,0x29,0x3D,0x3D,0x2B,0x2F,0x3D,
  0x13,0x13,0x13,0x11,0x11,0x13,0x13,0x13,0x3D,0x3B,0x32,0x3D,0x3C,0x3E,0x3B,0x29,0x40,0x28,0x3C,
  0x3D,0x3C,0x3D,0x3C,0x2D,0x3D,0x13,0x13,0x11,0x11,0x13,0x13,0x3E,0x3C,0x28,0x3E,0x3F,0x3B,0x28,
  0x3D,0x3A,0x29,0x2E,0x3E,0x3F,0x34,0x28,0x3E,0x3D,0x3B,0x3E,0x13,0x11,0x11,0x13,0x13,0x3D,0x2B,
  0x3C,0x3F,0x40,0x3C,0x12,0x40,0x3C,0x2F,0x3C,0x40,0x40,0x34,0x11,0x40,0x3E,0x3F,0x3C,0x13,0x11,
  0x11,0x13,0x14,0x3C,0x3E,0x3F,0x11,0x3E,0x3C,0x3A,0x35,0x3F,0x12,0x3F,0x3B,0x3A,0x3C,0x3E,0x12,
  0x28,0x3C,0x3C,0x12,0x11,0x11,0x13,0x13,0x32,0x32,0x3F,0x3D,0x37,0x36,0x3B,0x3F,0x40,0x40,0x3F,
  0x3F,0x3C,0x3B,0x37,0x3D,0x3C,0x3D,0x3C,0x13,0x11,0x11,0x13,0x13,0x3E,0x31,0x3B,0x39,0x34,0x23,
  0x40,0x3B,0x3E,0x40,0x3E,0x3B,0x40,0x40,0x3C,0x37,0x3B,0x3D,0x2A,0x14,0x11,0x11,0x13,0x13,0x3D,
  0x31,0x3D,0x33,0x33,0x3B,0x3A,0x3C,0x36,0x30,0x36,0x3C,0x35,0x3B,0x34,0x33,0x29,0x3E,0x3D,0x13,
  0x12,0x11,0x13,0x13,0x40,0x3E,0x28,0x34,0x3F,0x3F,0x3F,0x3D,0x3B,0x40,0x34,0x3D,0x3F,0x3F,0x3F,
  0x3C,0x3F,0x29,0x28,0x13,0x11,0x11,0x13,0x14,0x10,0x28,0x27,0x3D,0x35,0x40,0x40,0x28,0x3C,0x40,
  0x3D,0x28,0x40,0x40,0x35,0x3D,0x3B,0x28,0x12,0x13,0x11,0x11,0x13,0x13,0x13,0x40,0x3C,0x3D,0x3D,
  0x36,0x3D,0x27,0x3D,0x39,0x3D,0x27,0x33,0x36,0x3D,0x31,0x3E,0x10,0x13,0x13,0x11,0x11,0x13,0x13,
  0x13,0x13,0x40,0x3D,0x3F,0x3D,0x2D,0x3A,0x3C,0x3B,0x3C,0x3A,0x35,0x32,0x31,0x3F,0x40,0x13,0x13,
  0x13,0x11,0x11,0x13,0x13,0x12,0x12,0x12,0x22,0x3F,0x3D,0x3D,0x3D,0x3F,0x3D,0x3E,0x3D,0x29,0x3D,
  0x27,0x40,0x13,0x13,0x13,0x13,0x11,0x12,0x13,0x12,0x12,0x12,0x12,0x12,0x13,0x14,0x2A,0x28,0x3F,
  0x3D,0x3F,0x3F,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x11,0x12,0x13,0x12,0x13,0x13,0x13,0x12,
  0x13,0x14,0x14,0x13,0x14,0x13,0x14,0x14,0x14,0x13,0x13,0x13,0x13,0x13,0x13,0x13,0x11,0x11,0x12,
  0x12,0x14,0x15,0x15,0x14,0x14,0x13,0x13,0x13,0x12,0x13,0x14,0x13,0x13,0x13,0x13,0x13,0x13,0x12,
  0x13,0x12,0x11,0x12,0x12,0x12,0x12,0x12,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x12,0x11,
  0x11,0x11,0x11,0x11,0x11,0x12,0x11,0x11};


////////////////////////////////////////////////////////////////////////////////
static VOverlay *diskOverlay = NULL;


////////////////////////////////////////////////////////////////////////////////
void diskBlit (int x0, int y0) {
  if (diskLastActivity <= 0) {
    // check motors
    int motoron = (upd765_fdc->drive[0]->motoron || upd765_fdc->drive[1]->motoron);
    if (!motoron) {
      for (int f = 0; f < 4; ++f) {
        fdd_t *fdd = beta_get_fdd(f);
        if (fdd && fdd->motoron) {
          motoron = 1;
          break;
        }
      }
    }
    if (motoron) {
      if (diskOverlay == NULL) diskOverlay = createVOFromIcon(iconDisk);
      blitVO(diskOverlay, x0, y0, 96);
      return;
    }
  }
  if (diskLastActivity > 0 && diskAlpha > 0) {
    int64_t tt = timerGetMS();
    if (tt-diskLastActivity < 500+diskAlpha*10) {
      int alpha = diskAlpha;
      if (tt-diskLastActivity >= 500) {
        alpha -= (tt-diskLastActivity-500)/10;
        if (alpha <= 0) { diskLastActivity = 0; return; }
      }
      if (diskOverlay == NULL) diskOverlay = createVOFromIcon(iconDisk);
      blitVO(diskOverlay, x0, y0, alpha);
    } else {
      diskLastActivity = 0;
    }
  } else {
    diskLastActivity = 0;
  }
}
